/* USBasp main.c */
/* ̉ǂ́Airuka񂪍s܂
   2008N912`922
   2008N922 eXgJJn
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

#include "usbdrv.h"

/* ------------------------------------------------------------------------- */

#define	INCLUDE_MONITOR_CMD 0	// 62:POKE(),63:PEEK().
#define	INCLUDE_LED_CMD 	0	// 02:LEDR}h.

#define	USE_HID				0

/* ------------------------------------------------------------------------- */

#if	USE_HID
#define ID4    4
#define	SIZE4 32
#define ID5    5
#define	SIZE5 40
#define ID6    6
#define	SIZE6 48

PROGMEM char usbHidReportDescriptor[69] = {
    0x06, 0x00, 0xff,              // USAGE_PAGE (Generic Desktop)
    0x09, 0x01,                    // USAGE (Vendor Usage 1)
    0xa1, 0x01,                    // COLLECTION (Application)
    0x15, 0x00,                    //   LOGICAL_MINIMUM (0)
    0x26, 0xff, 0x00,              //   LOGICAL_MAXIMUM (255)
    0x75, 0x08,                    //   REPORT_SIZE (8)

    0x85, 0x01,                    //   REPORT_ID (1)
    0x95, 0x06,                    //   REPORT_COUNT (6)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0x85, 0x02,                    //   REPORT_ID (2)
    0x95, 0x0e,                    //   REPORT_COUNT (14)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0x85, 0x03,                    //   REPORT_ID (3)
    0x95, 0x16,                    //   REPORT_COUNT (22)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0x85, 0x04,                    //   REPORT_ID (4)
    0x95, 0x1e,                    //   REPORT_COUNT (30)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0x85, 0x05,                    //   REPORT_ID (5)
    0x95, 0x26,                    //   REPORT_COUNT (38)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0x85, 0x06,                    //   REPORT_ID (6)
    0x95, 0x2e,                    //   REPORT_COUNT (46)
    0x09, 0x00,                    //   USAGE (Undefined)
    0xb2, 0x02, 0x01,              //   FEATURE (Data,Var,Abs,Buf)

    0xc0                           // END_COLLECTION
};
/* Note: REPORT_COUNT does not include report-ID byte */
#endif

static uint8_t wait =60; // 160
static uint8_t mem61=61; // 160
static uint8_t mem62=62; // 160
static uint8_t mem63=63; // 160

static uchar hidStatus;			   // HID Report ID
//static uchar requestType;

//
//	Mobt@.
//
static uchar currentPosition, bytesRemaining; // Receive Data Pointer

typedef struct {
	uchar id[1];
	uchar buf[16];		// [39]
} ReportBuf_t;


static uchar result[8];	//Rg[]R}h̏ʃobt@(hostԑp)

static ReportBuf_t report;

// Mobt@͎Mobt@𗬗p.
//	AA擪1oCgReport IDuKv̂,1oCg.
#define	usbData report.buf
#define	buffer  report.id

//
#if	INCLUDE_MONITOR_CMD

//	[ǂݏR}h\.
typedef struct {
	uchar hidasp_cmd;	// 62=poke 63=peek
	uchar count;		// ǂݍ݃oCg.
	uchar *addr;		// ǂݏAhX.
	uchar memdata[16];	// ǂݍ݃f[^. ͏݃f[^[0] }XN[1]
} MonCommand_t;

static void cmd_poke(MonCommand_t *cmd)
{
	uchar *p=cmd->addr;
	if(cmd->memdata[1]) {	//}XNt̏.
		*p = (*p & cmd->memdata[1]) | cmd->memdata[0];
	}else{			//ׂ.
		*p = cmd->memdata[0];
	}
}
static void cmd_peek(MonCommand_t *cmd)
{
	uchar i;
	uchar *p=cmd->addr;
	for(i=0;i<(cmd->count);i++) {
		cmd->memdata[i]=*p++;
	}
}
#endif


// œKp
#define hbyte(a) (*((uchar*)&(a)+1))
#define lbyte(a) (*((uchar*)&(a)))
inline static uint8_t byte(uint8_t t) {return t;}

static void delay(uchar d) {
	do {	// 12clock loop = 1.0 usec * N
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
		asm("nop");
	} while(--d);
}

void delay100usec(uchar d)
{
	uchar i;
	for(i=0;i<d;i++) delay(100);
}

static uint8_t usi_trans(uint8_t data){
	USIDR=data;
	USISR=(1<<USIOIF);
	if(wait==0) {
#if	0
		uchar CR0=(1<<USIWM0)|(1<<USICS1)|(1<<USITC);
		USICR=CR0;
		uchar CR1=(1<<USIWM0)|(1<<USICS1)|(1<<USITC)|(1<<USICLK);
								USICR=CR1;	asm("nop");
		USICR=CR0;	asm("nop");	USICR=CR1;	asm("nop");
		USICR=CR0;	asm("nop");	USICR=CR1;	asm("nop");
		USICR=CR0;	asm("nop");	USICR=CR1;	asm("nop");
		USICR=CR0;	asm("nop");	USICR=CR1;	asm("nop");
		USICR=CR0;	asm("nop");	USICR=CR1;	asm("nop");
		USICR=CR0;	asm("nop");	USICR=CR1;	asm("nop");
		USICR=CR0;	asm("nop");	USICR=CR1;
#endif
	}else{
		do{
			delay(wait);
			USICR=(1<<USIWM0)|(1<<USICS1)|(1<<USICLK)|(1<<USITC);
		} while(!(USISR&(1<<USIOIF)));
	}
	return USIDR;
}

/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */


//
//	Rg[]Ŏ󂯎R}hpPbg.
//
typedef	struct {
	uchar bmRequestType;
	uchar cmd;
	uchar *adr;
	uchar data0;
	uchar data1;
	uchar wLength;
	uchar wLength_h;
} RxBuf;

//
//	cmd = [ 0 aa ccccc ]   a = area , c = cmd
//
enum {
	CMD_NOP  ,
	CMD_01	 ,
	CMD_02	 ,
	CMD_03	 ,
	CMD_04	 ,
	CMD_PEEK ,
	CMD_POKE ,
	CMD_BAUD ,
	CMD_MASK = 0x1f,
};


//
//	[ǂݏ̃IvV.
//
enum {
	AREA_RAM    = 0   ,
	AREA_EEPROM = 0x20,
	AREA_PGMEM  = 0x40,
	AREA_MASK	= 0x60,
};

/******************************************************************
 *	[ǂݏo.
 ******************************************************************
    0      1      2      3      4      5      6      7
 +------+------+-------------+------+------+-------------+
 | req  | cmd  |     adr     | len  |      |   wlength   |
 +------+------+-------------+------+------+-------------+
len͂O`W
UgpPbgiWoCgjŃf[^Ԃ.
 */
static void cmdPeek(RxBuf *q)
{
	uchar sub = q->cmd & AREA_MASK;
	if(sub == AREA_RAM) {
		memcpy(result,q->adr,q->data0);
	}else
	if(sub == AREA_PGMEM) {
		pgmemcpy(result,(int)q->adr,q->data0);
	}
}

/******************************************************************
 *	[.
 ******************************************************************
    0      1      2      3      4      5      6      7
 +------+------+-------------+------+------+-------------+
 | req  | cmd  |     adr     |data0 |data1 |   wlength   |
 +------+------+-------------+------+------+-------------+
data1[̂Ƃ́A}XNp^[Iȏŏ.

UgpPbg͕svA_~[łWoCgԂ.
 */
static void cmdPoke(RxBuf *q)
{
	uchar *p = (uchar *)q->adr;
	if(q->data1) {	//}XNt̏.
		*p = (*p & q->data1) | q->data0;
	}else{			//ׂ.
		*p = q->data0;
	}
}

uchar usbFunctionSetup(uchar data[8])
{
	RxBuf *q = (RxBuf *)data;
	uchar rqType = q->bmRequestType & USBRQ_TYPE_MASK;
	uchar cmd    = q->cmd & CMD_MASK;	//R}h.

  if(rqType == USBRQ_TYPE_VENDOR){    /* vendor request type */
	currentPosition = 0;                // initialize position index
	bytesRemaining = q->wLength;  // store the amount of data requested
	usbMsgPtr = result;
	if(cmd == CMD_PEEK) {
		cmdPeek(q);			// [ǂݏo.
		return 8;
//		return 0xff;
	}
	if(cmd == CMD_POKE) {
		cmdPoke(q);			// [.
		return 0xff;
	}
	if(cmd == CMD_BAUD) {
		wait=data[2];
//		cmdBaud(data[2],data[3],data[4]);	// {[[gݒ.
		return 0xff;
	}
//	delay100usec(wait);
	if(cmd == 0) {
		mem61 = q->bmRequestType;
		mem62 = bytesRemaining;
	}
	return 0xff;
  }
  return 0;
}

// Rg[]㑱f[^ĂꍇA8oCgPʂŎ󂯎.
// 	Eʂreport\̂ɓ.
//	ES󂯎Ahidasp_main()Ăяo.
uchar usbFunctionWrite(uchar *data, uchar len)
{
    uchar i;
    if(	len > bytesRemaining) {             // if this is the last incomplete chunk
        len = bytesRemaining;               // limit to the amount we can store
	}
    bytesRemaining -= len;

	delay100usec(wait);

    for(i = 0; i < len; i++) {
		currentPosition++;
//		report.id[currentPosition++] = data[i];

#if	0
			usi_trans(0);
			usi_trans(0);
			usi_trans(0);
			usi_trans(0);
#endif
	}
	// S󂯎Aobt@es.
    if( bytesRemaining == 0 ) {
		if( hidStatus > 0 ) {
//			hidasp_main(report.buf);
		}
	    return 1;	// return 1 if we have all data
	}
	return 0;		// continue data.
}

// Rg[]㑱f[^ĂꍇA8oCgPʂŎ󂯎.
// 	Eʂreport\̂ɓ.
//	ES󂯎Ahidasp_main()Ăяo.
uchar usbFunctionRead(uchar *data, uchar len)
{
    uchar i;
    if(	len > bytesRemaining) {             // if this is the last incomplete chunk
        len = bytesRemaining;               // limit to the amount we can store
	}
    bytesRemaining -= len;

	mem63 = len;
	delay100usec(wait);

    for(i = 0; i < len; i++) {
		currentPosition++;
		data[i] = result[i];
#if	0
//		report.id[currentPosition++] = data[i];
			usi_trans(0);
			usi_trans(0);
			usi_trans(0);
			usi_trans(0);
#endif
	}
	return len;		// continue data.
}

/*
       ATtiny2313
       ___    ___
RESET [1  |__| 20]Vcc
      [2       19]PB7(SCK)
      [3       18]PB6(MISO)
XTAL2 [4       17]PB5(MOSI)
XTAL1 [5       16]PB4(RST)
      [6       15]
PD3   [7       14]
PD4   [8       13]
      [9       12]
GND   [10      11]
       ~~~~~~~~~~

   ---------------------------------------
   SPI:     PB7-4 ===> [Target AVR Device]
   USB:     PD4   ===> USB D-
            PD3   ===> USB D+
   XTAL:    XTAL1,2 => Crystal 12MHz
   ---------------------------------------
*/

int main(void)
{

/* Port Directionݒ́Aȉ3 */
    DDRD = ~USBMASK;   /* all outputs except USB data */

//	ꍇPULL UPK{.
//	PORTB = (1<<4)|(1<<3);	/* RESET=High, PB3 LED(PWR) ON, PB2 LED(ACC) OFF */

    DDRB = ~(1<<5);    /* all outputs except USI input data */
	USICR=(1<<USIWM0)|(1<<USICS1)|(1<<USICLK);


	hidStatus = -1;
    usbInit();
    sei();
    for(;;){    /* main event loop */
        usbPoll();
    }
    return 0;
}
